import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import _extends from "@babel/runtime/helpers/esm/extends";

var _componentType;

var _excluded = ["type"],
    _excluded2 = ["type"],
    _excluded3 = ["type", "button", "leftAddon", "rightAddon", "leftIcon", "rightIcon", "children", "onClickLeftIcon", "onClickRightIcon", "size"];
import { forwardRef } from 'react';
import cx from 'classnames';
import PropTypes from 'prop-types';
import { BASE_CLASS_AREA_FOCUSABLE, BASE_CLASS_ITEM, SIZES, TYPES } from '../config.js';
import Mask from '../Mask/index.js';
import Password from '../Password/index.js';
import Input from './Component/index.js';
import InputAddons from './Wrappers/Addons/InputAddons.js';
import InputButton from './Wrappers/Button/InputButton.js';
import InputIcons from './Wrappers/Icons/InputIcons.js';
import { jsx as _jsx } from "react/jsx-runtime";
var componentType = (_componentType = {
  undefined: function undefined(_ref) {
    var props = _extends({}, _ref);

    return [Input, _extends({}, props)];
  }
}, _componentType[TYPES.SUI_PASSWORD] = function (_ref2) {
  var type = _ref2.type,
      props = _objectWithoutPropertiesLoose(_ref2, _excluded);

  return [Password, _extends({}, props)];
}, _componentType[TYPES.MASK] = function (_ref3) {
  var type = _ref3.type,
      props = _objectWithoutPropertiesLoose(_ref3, _excluded2);

  return [Mask, _extends({}, props)];
}, _componentType);
var BaseInput = /*#__PURE__*/forwardRef(function (_ref4, forwardedRef) {
  var type = _ref4.type,
      button = _ref4.button,
      leftAddon = _ref4.leftAddon,
      rightAddon = _ref4.rightAddon,
      leftIcon = _ref4.leftIcon,
      rightIcon = _ref4.rightIcon,
      children = _ref4.children,
      onClickLeftIcon = _ref4.onClickLeftIcon,
      onClickRightIcon = _ref4.onClickRightIcon,
      _ref4$size = _ref4.size,
      size = _ref4$size === void 0 ? SIZES.MEDIUM : _ref4$size,
      inputProps = _objectWithoutPropertiesLoose(_ref4, _excluded3);

  var _ref5 = componentType[type] ? componentType[type](_extends({
    type: type,
    size: size
  }, inputProps)) : componentType[undefined](_extends({
    type: type,
    size: size
  }, inputProps)),
      Component = _ref5[0],
      passedProps = _ref5[1];

  return /*#__PURE__*/_jsx(InputButton, {
    button: button,
    children: /*#__PURE__*/_jsx(InputAddons, {
      leftAddon: leftAddon,
      rightAddon: rightAddon,
      shape: inputProps.shape,
      size: size,
      children: /*#__PURE__*/_jsx("span", {
        className: cx(BASE_CLASS_ITEM, BASE_CLASS_AREA_FOCUSABLE),
        children: /*#__PURE__*/_jsx(InputIcons, {
          leftIcon: leftIcon,
          rightIcon: rightIcon,
          onClickLeftIcon: onClickLeftIcon,
          onClickRightIcon: onClickRightIcon,
          children: /*#__PURE__*/_jsx(Component, _extends({
            ref: forwardedRef
          }, passedProps, {
            size: size,
            children: children
          }))
        })
      })
    })
  });
});
export default BaseInput;
export { BaseInput };